#include "blitlib.h"
#include <stdlib.h> 
#include <math.h> 
HRESULT				dderror;
//#define TRANSCOLOR	0000000000011111b
WORD					TRANSCOLOR;
DWORD					bitmask,bitmask1,bitmask2,bitmask3,bitmask4;
DWORD					bmask1,bmask2,bmask3,bmask4,imulmask;
DWORD					gmaskdw,bmaskdw;
WORD					gmaskw, bmaskw;
WORD					scol,dcol;
int						x, y, x1, dx, dy, dpitch;
int						deltax, deltay, xpos, ypos;
int						pixelformat;
short					*alphatable, red1, red2, green1, green2, blue1, blue2;
short					*coltable;
short					gshift;
DWORD					alphashift;
DWORD					bover, gover, rover, pureblue, puregreen, purered;
DWORD					NOTbover, NOTgover, NOTrover;
unsigned char	darkshift;
unsigned char	*bob;
DWORD					*xchp;
DWORD					*ychp;
//static int					xchp[1000];
//static int					ychp[1000];
int					mysin[720], mycos[720];
DDSURFACEDESC		ddsdBack, ddsdSpr;

void InitBlit (int mode, WORD tcolor)
{
	int						icount,jcount,k;
	TRANSCOLOR=(WORD)tcolor;
	if (mode==555) {	//555 format
		bitmask = 0x3def3def;
		gmaskw=0x03e0;
		gmaskdw=0x03e0;
		imulmask=0x3e07c1f;
		gshift=5;
		//purered=0x7c00;
		//puregreen=0x03e0;
		//pureblue=0x01f;
		purered=0x1f;
		puregreen=0x07c00;
		pureblue=0x3e00000;
		pixelformat=555;

		rover=0x60;
		gover=0x18000;
		bover=0xC000000;
	}
	else if (mode==565)   {
		bitmask = 0x7bef7bef;
		gmaskw=0x07e0;			//green mask
		gmaskdw=0x07e0;
		imulmask=0x3e0fc1f;
		gshift=6;
		//purered=0xf800;
		//puregreen=0x07e0;
		//pureblue=0x01f;
		purered=0x1f;
		puregreen=0x0fc00;
		pureblue=0x3e00000;
//		rover=0x20;
//		gover=0x10000;
//		bover=0x4000000;
		rover=0x60;
		gover=0x30000;
		bover=0xC000000;
		NOTrover=!rover;
		NOTgover=!gover;
		NOTbover=!bover;	
		pixelformat=565;
	}
	else MessageBox(NULL, TEXT("Bad Mode...555 or 565 supported"), 
			NULL, MB_ICONERROR|MB_OK );

	bmaskdw=0x01f;			//blue mask
	bmaskw=0x01f;			

	bitmask1=bitmask;
	bitmask2=(bitmask>>1)&bitmask;
	bitmask3=(bitmask2>>1)&bitmask2;
	bitmask4=(bitmask3>>1)&bitmask3;
	alphatable=(short *)malloc( (1024*sizeof(short)+10) *33);
	k=32;
	do  {
		jcount=31;
		do  {
			icount=31;
			do  {
				alphatable[icount+jcount*32+1024*k+1]=k*icount/32 +(32-k)*jcount/32;
				icount--;
				}	while (icount >=0);
			jcount--;
		}	while (jcount >=0);
	  k--;
	}	while (k >=0);

	coltable=(short *)malloc((32+10)*32);
	k=0;
	do  {
		icount=31;
		do  {
			coltable[icount+32*k+1]=icount;
			icount--;
			}	while (icount >=0);
	  k--;
	}	while (k >=0);

	bob=(unsigned char *)malloc(25*200+200);
	int j=199;
	do  {
		int i=24;
		do  {
			bob[i+j*25]=0;
			//if (i==0||i==24||j==0||j==199) bob[i+j*25]=0xFF;
			if (((12-i)*(12-i)+(100-j)*(100-j)/16)<100 ) bob[i+j*25]=0xFF;
			i--;
			}	while (i >=0);
			j--;
		}	while (j >=0);

	xchp=(DWORD *)malloc(1000*sizeof(DWORD));;
	ychp=(DWORD *)malloc(1000*sizeof(DWORD));;
	
	for (int i=0;i<720;i++)  {
		mysin[i]=int(sin(i*3.1415/180)*128);
		mycos[i]=int(cos(i*3.1415/180)*128);
		}	


	return;
}

void SetTrans(WORD tcolor)  {
	TRANSCOLOR=tcolor;
}

void setbmask(int srcalpha)  {
	switch(srcalpha)
	{
		case 0:
			bmask1=0;
			bmask2=0;
			bmask3=0;
			bmask4=0;
			break;
		case 1:
			bmask1=0;
			bmask2=0;
			bmask3=0;
			bmask4=bitmask4;
			break;
		case 2:
			bmask1=0;
			bmask2=0;
			bmask3=bitmask3;
			bmask4=0;
			break;
		case 3:
			bmask1=0;
			bmask2=0;
			bmask3=bitmask3;
			bmask4=bitmask4;
			break;
		case 4:
			bmask1=0;
			bmask2=bitmask2;
			bmask3=0;
			bmask4=0;
			break;
		case 5:
			bmask1=0;
			bmask2=bitmask2;
			bmask3=0;
			bmask4=bitmask4;
			break;
		case 6:
			bmask1=0;
			bmask2=bitmask2;
			bmask3=bitmask3;
			bmask4=0;
			break;
		case 7:
			bmask1=0;
			bmask2=bitmask2;
			bmask3=bitmask3;
			bmask4=bitmask4;
			break;
		case 8:
			bmask1=bitmask1;
			bmask2=0;
			bmask3=0;
			bmask4=0;
			break;
		case 9:
			bmask1=bitmask1;
			bmask2=0;
			bmask3=0;
			bmask4=bitmask4;
			break;
		case 10:
			bmask1=bitmask1;
			bmask2=0;
			bmask3=bitmask3;
			bmask4=0;
			break;
		case 11:
			bmask1=bitmask1;
			bmask2=0;
			bmask3=bitmask3;
			bmask4=bitmask4;
			break;
		case 12:
			bmask1=bitmask1;
			bmask2=bitmask2;
			bmask3=0;
			bmask4=0;
			break;
		case 13:
			bmask1=bitmask1;
			bmask2=bitmask2;
			bmask3=0;
			bmask4=bitmask4;
			break;
		case 14:
			bmask1=bitmask1;
			bmask2=bitmask2;
			bmask3=bitmask3;
			bmask4=0;
			break;
		case 15:
			bmask1=bitmask1;
			bmask2=bitmask2;
			bmask3=bitmask3;
			bmask4=bitmask4;
			break;
		case 16:
			bmask1=bitmask1;
			bmask2=bitmask2;
			bmask3=bitmask3;
			bmask4=bitmask4;
			break;
	}
	return;
}


void MaskBlit(LPDIRECTDRAWSURFACE pSrc, LPDIRECTDRAWSURFACE pDst, int sprX, int sprY, int blitmode, int srcalpha, int destalpha, RECT srcrect, int resv){
	DDSURFACEDESC		ddsdBack, ddsdSpr;
	
	//bob[0]=0xFF;
	//bob[9]=0x80;
	//bob[10]=0xFF;
	//bob[11]=0xFF;
	//
	//bob[12]=0x03;
	

	memset( &ddsdSpr, 0, sizeof( ddsdSpr ) );
    ddsdSpr.dwSize = sizeof( ddsdSpr );
	if (!SUCCEEDED(pSrc->GetSurfaceDesc( &ddsdSpr ))) return;

//*********************************************************************
										//and transparency
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);


			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		edx, bob

					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

//					mov		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					//mov		ecx, deltay
					mov		ecx, 200
			Loopmaska:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
					shr		ecx, 3

			Loopmaskb:
					mov		bx, 8
					mov		ax, [edx]
					test	ax,	1		//0xFF
					jnz		Lilloop
					add		edi, 16
					add		esi, 16
					jmp		Skipmask
		
			Lilloop:
					shl		ax, 1
					//test	ax, 0x80
					jnc		not1
					push	edx
					mov		edx, [esi]
					mov		[edi], edx
					pop		edx
			not1:			
					add		edi, 2
					add		esi, 2
					dec		bx
					jnz		Lilloop

			Skipmask:
					inc		edx
					//add		edi, 2
					dec		ecx
					jnz		LoopMaskb
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz	Loopmaska
				}
			}

			//pDst->Unlock(ddsdBack.lpSurface);
			//pSrc->Unlock(ddsdSpr.lpSurface);

}


//big daddy blitting routine
void MyBlit(LPDIRECTDRAWSURFACE pSrc, LPDIRECTDRAWSURFACE pDst, int sprX, int sprY, int blitmode, int srcalpha, int destalpha, RECT srcrect, int nangle, int nsize, int resv)
{
	DDSURFACEDESC		ddsdBack, ddsdSpr;
	RECT				rect;
	if (blitmode!=51&&blitmode!=31&&blitmode!=34
		&&blitmode!=36&&blitmode!=14) srcalpha=srcalpha/2;	
	if (blitmode==30&&srcalpha==16) return;	
	if (blitmode>=70&&blitmode<80)  {
		if (pixelformat==555) blitmode*=10;
		if (srcalpha<8) darkshift=1;
		else darkshift=0;
	}
	if (blitmode==14&&pixelformat==555) blitmode*=10;	
	if (blitmode==31&&pixelformat==555) blitmode*=10;	
	if (blitmode==34&&pixelformat==555) blitmode*=10;	
	if (blitmode==35&&pixelformat==555) blitmode*=10;	
	if (blitmode==36&&pixelformat==555) blitmode*=10;	
	if (blitmode==51&&pixelformat==555) blitmode*=10;	
	if (blitmode==63&&pixelformat==555) blitmode*=10;	
	if (blitmode==64&&pixelformat==555) blitmode*=10;	
	//set up for the lock, and get the pitch and width etc ready
	memset( &ddsdSpr, 0, sizeof( ddsdSpr ) );
    ddsdSpr.dwSize = sizeof( ddsdSpr );
	if (!SUCCEEDED(pSrc->GetSurfaceDesc( &ddsdSpr ))) return;

	
	switch(blitmode)
	{
//*********************************************************************
		case 0:				//plain old bltfast
			//SetRect(&rect, 0, 0, ddsdSpr.dwWidth, ddsdSpr.dwHeight);
			pDst->BltFast(sprX, sprY, pSrc, &srcrect, DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
			//pDst->BltFast(sprX, sprY, pSrc, &rect, DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
			break;
//*********************************************************************
		case 1:				//asm reproduction of blitfast
			return;
			//old routing, does not use passed rectangle, 
			//can be used if full surface expected
			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, ddsdSpr.lpSurface
					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, ddsdSpr.dwHeight
			Loop1a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, ddsdSpr.dwWidth
					shr		ecx, 1
					test	edi, 3
					jz		Aligned1 // target aligned ?
					movsw									// do align
					dec		ecx
			Aligned1:
					rep		movsd
					test	edi, 3
					jz		NxtLne1	// target aligned ?
					movsw
			NxtLne1:
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop1a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 2:				//bltfast with clipping
			return;
			//old routing, does not use passed rectangle, but 
			//instead calculates clipping bassed on full image
			deltax=ddsdSpr.dwWidth;
			deltay=ddsdSpr.dwHeight;
			
			if (sprX<0) {x=0-sprX; sprX=0; deltax+=sprX;}
			else {x=0;}
			if (sprY<0) {y=0-sprY; sprY=0; deltax+=sprY;}
			else {y=0;}
			if ((sprX+ddsdSpr.dwWidth)>640) {
				deltax+=640-(sprX+ddsdSpr.dwWidth);
				//dpitch=(ddsdSpr.dwWidth-deltax)*2;
				}
			if ((sprY+ddsdSpr.dwHeight)>480) deltay+=480-(sprY+ddsdSpr.dwHeight);

			SetRect(&rect, x, y, deltax, deltay);
			pDst->BltFast(sprX, sprY, pSrc, &rect, DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
			break;
//*********************************************************************
		case 3:				//asm reproduction of blitfast with clipping
			return;
			//old routing, does not use passed rectangle, but 
			//instead calculates clipping bassed on full image

			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=ddsdSpr.dwWidth;
			deltay=ddsdSpr.dwHeight;
			
			if (sprX<0) {x=0-sprX; deltax+=sprX; sprX=0;}
			else {x=0;}
			if (sprY<0) {y=0-sprY; deltay+=sprY; sprY=0;}
			else {y=0;}
			if ((sprX+ddsdSpr.dwWidth)>640) {
				deltax+=640-(sprX+ddsdSpr.dwWidth);
				//dpitch=(ddsdSpr.dwWidth-deltax)*2;
				}
			if ((sprY+ddsdSpr.dwHeight)>480) deltay+=480-(sprY+ddsdSpr.dwHeight);
			

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop3a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
					test ecx, 1
					jz		Notodd3	// target aligned ?
					movsw
			Notodd3:
					shr		ecx, 1
					test	edi, 3
					jz		Aligned3 // target aligned ?
					movsw									// do align
					dec		ecx
			Aligned3:
					rep		movsd
//are these next three lines needed?
					test	edi, 3
					jz		NxtLne3	// target aligned ?
					movsw
			NxtLne3:
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop3a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 4:				//plain old bltfast with passed rectangle
			pDst->BltFast(sprX, sprY, pSrc, &srcrect, DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
			break;

//*********************************************************************
		case 5:				//asm reproduction of blitfast with passed rect
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop5a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
					test ecx, 1
					jz		Notodd5	// target aligned ?
					movsw
			Notodd5:
					shr		ecx, 1
					test	edi, 3
					jz		Aligned5 // target aligned ?
					movsw									// do align
					dec		ecx
			Aligned5:
					rep		movsd
					test	edi, 3
					jz		NxtLne5	// target aligned ?
					movsw
			NxtLne5:
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop5a
				}
			}



			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;


//*********************************************************************
		case 10:			//plain old blitfast again, this time with color key
//	    SetRect(&rect, 0, 0, 200, 200);
	    //SetRect(&rect, 0, 0, ddsdSpr.dwWidth, ddsdSpr.dwHeight);
		pDst->BltFast(sprX, sprY, pSrc, &srcrect, DDBLTFAST_WAIT|DDBLTFAST_SRCCOLORKEY);
		//pDst->BltFast(sprX, sprY, pSrc, &rect, DDBLTFAST_WAIT|DDBLTFAST_SRCCOLORKEY);
			break;
//*********************************************************************
		case 11:			//asm copy of blitfast with color key
			return;
			//old routing, does not use passed rectangle
			//can be used if know won't be off edges

			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, ddsdSpr.lpSurface
					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, ddsdSpr.dwHeight
			Loop11a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, ddsdSpr.dwWidth
			Loop11b:
					mov		ax, [esi]
					cmp		ax, TRANSCOLOR
					je		Skip11
					mov		[edi], ax
			Skip11:
					add		esi, 2
					add		edi, 2
					loop	Loop11b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop11a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 12:				//asm reproduction of blitfast with passed rect
										//and transparency
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop12a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop12b:
					mov		ax, [esi]
					cmp		ax, TRANSCOLOR
					je		Skip12
					mov		[edi], ax
			Skip12:
					add		esi, 2
					add		edi, 2
					loop	Loop12b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop12a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 13:				//rotate
										//and transparency
			int	xa, ya, dxa, dya, intxa, intya;
			int checkdir;
			checkdir=0;
			DWORD *temp;
			int i;
			//static int count, size, sizedir, alpha;
			DWORD	xstart,ystart;

			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;
			//if (sizedir==0) sizedir=2;
			//count+=1;
			//if (count>3) {count-=3;alpha+=1;}
//			size+=sizedir;
//			if (size>256) {size=256;sizedir*=-1;}
//			if (size<4) {size=4;sizedir*=-1;}
//			size=200;
//			alpha+=2;
//			if (alpha>360) alpha-=360;
//			if (alpha<=0) alpha+=360;
			if (nangle>360) nangle-=360;
			if (nangle<=0) nangle+=360;
			xa=0;
			ya=0;
			dxa=mycos[nangle]*128/nsize;
			dya=mysin[nangle]*128/nsize;
//			intxa=abs(dxa/128);
//			intya=abs(dya/128);
//			dxa=dxa%128;
//			dya=dya%128;

			xstart=DWORD((srcrect.right+srcrect.left)/2-sqrt(deltax*deltax/2)*sin((45-nangle)*3.1415/180));
			ystart=DWORD((srcrect.top+srcrect.bottom)/2-sqrt(deltax*deltax/2)*cos((45-nangle)*3.1415/180));

			deltax=deltax*nsize/128;
			deltay=deltay*nsize/128;

			for (i=0;i<deltax+1;i++) {
			  xa+=dxa;
				ya+=dya;
				
				xchp[i]=0;
				ychp[i]=0;
				intxa=abs(xa/128);
				if (intxa<0)intxa=0;
				if (intya<0)intya=0;
				if (intxa>deltax)intxa=deltax;
				if (intya>deltay)intya=deltay;
				intya=abs(ya/128);
				if (xa>128) {
					xchp[i]+=2*intxa;
					ychp[i]+=ddsdSpr.lPitch*intxa;
					xa-=128*intxa;
				} else if (xa<-128) {
					xchp[i]-=2*intxa;
					ychp[i]-=ddsdSpr.lPitch*intxa;
					xa+=128*intxa;
				}
				if (ya>128) {
					xchp[i]+=ddsdSpr.lPitch*intya;
					ychp[i]-=2*intya;
					ya-=128*intya;
				} else if (ya<-128) {
					xchp[i]-=ddsdSpr.lPitch*intya;
					ychp[i]+=2*intya;
					ya+=128*intya;
				}
			}

			if ((sprX+deltax)>=640) deltax=640-sprX;	
			if ((sprY+deltay)>=480) deltay=480-sprY;	

			/*
			xstart=DWORD((srcrect.right+srcrect.left)/2-sqrt(deltax*deltax/2)*sin((45-nangle)*3.1415/180));
			ystart=DWORD((srcrect.top+srcrect.bottom)/2-sqrt(deltax*deltax/2)*cos((45-nangle)*3.1415/180));

			deltax=deltax*nsize/128;
			deltay=deltay*nsize/128;
			xpos=xstart;
			ypos=ystart;
			for (i=0;i<deltax+1;i++) {
			  xa+=dxa;
				ya+=dya;
				
				xchp[i]=0;
				ychp[i]=0;
				intxa=abs(xa/128);
				intya=abs(ya/128);
				if (xa>128) {
					xpos+=intxa;
					if ((0<xpos)&&(xpos<128)) xchp[i]+=2*intxa;
					if ((0<ypos)&&(ypos<128)) ychp[i]+=ddsdSpr.lPitch*intxa;
					xa-=128*intxa;
				} else if (xa<-128) {
					xpos-=intxa;
					if ((0<xpos)&&(xpos<128)) xchp[i]-=2*intxa;
					if ((0<ypos)&&(ypos<128)) ychp[i]-=ddsdSpr.lPitch*intxa;
					xa+=128*intxa;
				}
				if (ya>128) {
					ypos+=intya;
					if ((0<ypos)&&(ypos<128)) ychp[i]-=2*intya;
					if ((0<xpos)&&(xpos<128)) xchp[i]+=ddsdSpr.lPitch*intya;
					ya-=128*intya;
				} else if (ya<-128) {
					ypos-=intya;
					if ((0<ypos)&&(ypos<128)) ychp[i]+=2*intya;
					if ((0<xpos)&&(xpos<128)) xchp[i]-=ddsdSpr.lPitch*intya;
					ya+=128*intya;
				}
			}

			if ((sprX+deltax)>=640) deltax=640-sprX;	
			if ((sprY+deltay)>=480) deltay=480-sprY;	

			if (xstart<0) xstart=0;
			if (ystart<0) ystart=0;
			if (xstart>128) xstart=128;
			if (ystart>128) ystart=128;
			xpos=xstart;
			ypos=ystart;
			for (i=0;i<deltax+1;i++) {
				intxa=xchp[i]
				ypos=ypos+ychp[i]/ddsdSpr.lPitch;

				if (xpos <0) {xchp[i]=0;}
				if (ypos <0) {ychp[i]=0;}
//				if (xpos>=(128)) xchp[i]=0;
//				if (ypos>=(128)) ychp[i]=0;
			}
			if (xstart<0) xstart=0;
			if (ystart<0) ystart=0;
			if (xstart>=128) xstart=127;
			if (ystart>=128) ystart=127;
*/
			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			//pDst->Unlock(ddsdBack.lpSurface);
			//pSrc->Unlock(ddsdSpr.lpSurface);

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		ebx, xchp
					mov		edx, ychp
					mov		esi, ystart
					imul	esi, ddsdSpr.lPitch
					add		esi, xstart
					add		esi, xstart
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop13a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop13b:
					mov		ax, [esi]
					cmp		ax, TRANSCOLOR
					je		Skip13
					mov		[edi], ax
			Skip13:
					//mov		edx, xchp
					//lea		edx, [4*ecx+edx]
					add		esi, [ebx+4*ecx]
					//add		esi, ddsdSpr.lPitch
					add		edi, 2
					loop	Loop13b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					//mov		edx, ychp
					//lea		edx, [edx+4*ecx]
					//add		esi, [edx+4*ecx]
					add		esi, [4*ecx+edx]
					loop	Loop13a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 14:				//rotate
										//and transparency
//			int	xa, ya, dxa, dya, intxa, intya;
//			DWORD *temp;
//			int i;
			//static int count, size, sizedir, alpha;
//			DWORD	xstart,ystart;

			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;
			//if (sizedir==0) sizedir=2;
			//count+=1;
			//if (count>3) {count-=3;alpha+=1;}
//			size+=sizedir;
//			if (size>256) {size=256;sizedir*=-1;}
//			if (size<4) {size=4;sizedir*=-1;}
//			size=200;
//			alpha+=2;
//			if (alpha>360) alpha-=360;
//			if (alpha<=0) alpha+=360;
			if (nangle>360) nangle-=360;
			if (nangle<=0) nangle+=360;
			xa=0;
			ya=0;
			dxa=mycos[nangle]*128/nsize;
			dya=mysin[nangle]*128/nsize;
//			intxa=abs(dxa/128);
//			intya=abs(dya/128);
//			dxa=dxa%128;
//			dya=dya%128;
			
			xstart=DWORD((srcrect.right+srcrect.left)/2-sqrt(deltax*deltax/2)*sin((45-nangle)*3.1415/180));
			ystart=DWORD((srcrect.top+srcrect.bottom)/2-sqrt(deltax*deltax/2)*cos((45-nangle)*3.1415/180));

			deltax=deltax*nsize/128;
			deltay=deltay*nsize/128;

			for (i=0;i<deltax+1;i++) {
			  xa+=dxa;
				ya+=dya;
				
				xchp[i]=0;
				ychp[i]=0;
				intxa=abs(xa/128);
				if (intxa<0)intxa=0;
				if (intya<0)intya=0;
				if (intxa>deltax)intxa=deltax;
				if (intya>deltay)intya=deltay;
				intya=abs(ya/128);
				if (xa>128) {
					xchp[i]+=2*intxa;
					ychp[i]+=ddsdSpr.lPitch*intxa;
					xa-=128*intxa;
				} else if (xa<-128) {
					xchp[i]-=2*intxa;
					ychp[i]-=ddsdSpr.lPitch*intxa;
					xa+=128*intxa;
				}
				if (ya>128) {
					xchp[i]+=ddsdSpr.lPitch*intya;
					ychp[i]-=2*intya;
					ya-=128*intya;
				} else if (ya<-128) {
					xchp[i]-=ddsdSpr.lPitch*intya;
					ychp[i]+=2*intya;
					ya+=128*intya;
				}
			}

			if ((sprX+deltax)>=640) deltax=640-sprX;	
			if ((sprY+deltay)>=480) deltay=480-sprY;	

			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
//			pDst->Unlock(ddsdBack.lpSurface);
//			pSrc->Unlock(ddsdSpr.lpSurface);

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		ebx, xchp
					mov		esi, ystart
					imul	esi, ddsdSpr.lPitch
					add		esi, xstart
					add		esi, xstart
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop14a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop14b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip14
					
					//spread the sprite pixel
					mov		eax, ecx
					mov		edx, ecx
					shl		eax, 21
					and		edx, 0x7e0					//gmaskdw
					shr		ecx, 11
					shl		edx, 5
					or		eax, ecx
					or		eax, edx
					and		eax, 0x3e0fc1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		ebx, ecx
					mov		edx, ecx
					shl		ebx, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background


					//and		ebx, 0x3e0fc1f	//imulmask
					imul	eax, srcalpha
					imul	ebx, destalpha
					
					shr		eax, 5
					shr		ebx, 5

					and		eax, 0x3e0fc1f	//imulmask
					and		ebx, 0x3e0fc1f	//imulmask

					add		eax, ebx


					test  eax, 0xC030060			//test all at once
					jz		NoOver14
//					mov		eax, 0x3E0FC1F

					test  eax, 0xC000000			//bover
					jz		NobOver14
					//xor		eax, bover
					or		eax, 0x3e00000			//pureblue
			NobOver14:
					test  eax, 0x30000				//gover
					jz		NogOver14
					//xor		eax, gover
					or		eax, 0x0fc00				//puregreen
			NogOver14:
					test  eax, 0x60						//rover
					jz		NorOver14
					//xor		eax, rover
					or		eax, 0x1f						//purered
			NorOver14:

			NoOver14:
					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shr ax, 5
					shl cx, 11
					and eax, 0x7e0					//gmaskdw
					shr edx, 21
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel

			Skip14:
					pop		ecx
					mov		edx, xchp
					add		esi, [edx+4*ecx]
					//mov		edx, xchp
					//lea		edx, [4*ecx+ebx]
					//lea		edx, [4*ecx+edx]
					//mov		edx, ecx
					//shl		edx, 2
					//add		edx, xchp
					//mov		eax, [edx]
					//add		esi, [edx]
					//add		esi, ddsdSpr.lPitch
					add		edi, 2
					dec		ecx
					jnz		Loop14b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					mov		edx, ychp
					add		esi, [edx+4*ecx]

					dec		ecx
					jnz		Loop14a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 140:				//rotate
										//and transparency
//			int	xa, ya, dxa, dya, intxa, intya;
//			DWORD *temp;
//			int i;
			//static int count, size, sizedir, alpha;
//			DWORD	xstart,ystart;

			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;
			//if (sizedir==0) sizedir=2;
			//count+=1;
			//if (count>3) {count-=3;alpha+=1;}
//			size+=sizedir;
//			if (size>256) {size=256;sizedir*=-1;}
//			if (size<4) {size=4;sizedir*=-1;}
//			size=200;
//			alpha+=2;
//			if (alpha>360) alpha-=360;
//			if (alpha<=0) alpha+=360;
			if (nangle>360) nangle-=360;
			if (nangle<=0) nangle+=360;
			xa=0;
			ya=0;
			dxa=mycos[nangle]*128/nsize;
			dya=mysin[nangle]*128/nsize;
//			intxa=abs(dxa/128);
//			intya=abs(dya/128);
//			dxa=dxa%128;
//			dya=dya%128;
			
			xstart=DWORD((srcrect.right+srcrect.left)/2-sqrt(deltax*deltax/2)*sin((45-nangle)*3.1415/180));
			ystart=DWORD((srcrect.top+srcrect.bottom)/2-sqrt(deltax*deltax/2)*cos((45-nangle)*3.1415/180));
			
			deltax=deltax*nsize/128;
			deltay=deltay*nsize/128;

			for (i=0;i<deltax+1;i++) {
			  xa+=dxa;
				ya+=dya;
				

				xchp[i]=0;
				ychp[i]=0;
				intxa=abs(xa/128);
				intya=abs(ya/128);
				if (xa>128) {
					xchp[i]+=2*intxa;
					ychp[i]+=ddsdSpr.lPitch*intxa;
					xa-=128*intxa;
				} else if (xa<-128) {
					xchp[i]-=2*intxa;
					ychp[i]-=ddsdSpr.lPitch*intxa;
					xa+=128*intxa;
				}
				if (ya>128) {
					xchp[i]+=ddsdSpr.lPitch*intya;
					ychp[i]-=2*intya;
					ya-=128*intya;
				} else if (ya<-128) {
					xchp[i]-=ddsdSpr.lPitch*intya;
					ychp[i]+=2*intya;
					ya+=128*intya;
				}
			}

			if ((sprX+deltax)>=640) deltax=640-sprX;	
			if ((sprY+deltay)>=480) deltay=480-sprY;	

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
//			pDst->Unlock(ddsdBack.lpSurface);
//			pSrc->Unlock(ddsdSpr.lpSurface);

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		ebx, xchp
					mov		esi, ystart
					imul	esi, ddsdSpr.lPitch
					add		esi, xstart
					add		esi, xstart
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop140a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop140b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip140
					
					//spread the sprite pixel
					mov		eax, ecx
					mov		edx, ecx
					shl		eax, 21
					and		edx, 0x3e0					//gmaskdw
					shr		ecx, 10
					shl		edx, 5
					or		eax, ecx
					or		eax, edx
					and		eax, 0x3e07c1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		ebx, ecx
					mov		edx, ecx
					shl		ebx, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 10
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565


					//eax contains sprite, ebx contains background


					//and		ebx, 0x3e0fc1f	//imulmask
					imul	eax, srcalpha
					imul	ebx, destalpha
					
					shr		eax, 5
					shr		ebx, 5

					and		eax, 0x3e07c1f	//imulmask
					and		ebx, 0x3e07c1f	//imulmask

					add		eax, ebx

					test  eax, 0xC018060			//test all at once
					jz		NoOver140
//					mov		eax, 0x3E0FC1F

					test  eax, 0xC000000			//bover
					jz		NobOver140
					//xor		eax, bover
					or		eax, 0x3e00000			//pureblue
			NobOver140:
					test  eax, 0x18000				//gover
					jz		NogOver140
					//xor		eax, gover
					or		eax, 0x07c00				//puregreen
			NogOver140:
					test  eax, 0x60						//rover
					jz		NorOver140
					//xor		eax, rover
					or		eax, 0x1f						//purered
			NorOver140:

			NoOver140:
					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shr ax, 5
					shl cx, 10
					and eax, 0x3e0					//gmaskdw
					shr edx, 21
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel

			Skip140:
					pop		ecx
					mov		edx, xchp
					add		esi, [edx+4*ecx]
					//mov		edx, xchp
					//lea		edx, [4*ecx+ebx]
					//lea		edx, [4*ecx+edx]
					//mov		edx, ecx
					//shl		edx, 2
					//add		edx, xchp
					//mov		eax, [edx]
					//add		esi, [edx]
					//add		esi, ddsdSpr.lPitch
					add		edi, 2
					dec		ecx
					jnz		Loop140b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					mov		edx, ychp
					add		esi, [edx+4*ecx]

					dec		ecx
					jnz		Loop140a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;


//*********************************************************************
		case 20:				//50% alpha blending
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loop20a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
					shr		ecx, 1
					test	edi, 3
					jz		Loop20b // target aligned

					// target unaligned, do align
					mov		ax, [esi]				// get sprite pixel
					mov		bx, [edi]       // get background pixel
					shr		eax, 1          // shift spr pix bits right
					shr		ebx, 1          // shift bck pix bits right
					and		eax, bitmask    // clip spr
					and		ebx, bitmask    // clip bck
					add		eax, ebx        // add it
					mov		[edi], ax       // store new pixel
					add		esi, 2
					add		edi, 2
					dec		ecx

			Loop20b:
					mov		eax, [esi]       // get 2 sprite pixels
					mov		ebx, [edi]       // get 2 sprite pixels
					shr		eax, 1           // shift spr pix bits right
					shr		ebx, 1           // shift bck pix bits right
					and		eax, bitmask     // clip spr
					and		ebx, bitmask     // clip bck
					add		eax, ebx         // add it
					mov		[edi], eax       // store new pixels
					add		esi, 4           // move to next 2 pixels
					add		edi, 4
					loop	Loop20b

					test	edi, 3
					jz		NxtLne20 // target aligned
					mov		ax, [esi]				// get sprite pixel
					mov		bx, [edi]       // get background pixel
					shr		eax, 1          // shift spr pix bits right
					shr		ebx, 1          // shift bck pix bits right
					and		eax, bitmask    // clip spr
					and		ebx, bitmask    // clip bck
					add		eax, ebx        // add it
					mov		[edi], ax       // store new pixel

			NxtLne20:
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop20a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;


//*********************************************************************
		case 30:		//alpha blending with color key
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop30a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop30b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip30

					mov		ebx, eax
					mov     edx, eax
					
					shr		eax, 1
					and		eax, bmask1    
					sub		ebx, eax       
					
					mov		eax, edx
					shr		eax, 2
					and		eax, bmask2    
					sub		ebx, eax       

					mov		eax, edx
					shr		eax, 3
					and		eax, bmask3    
					sub		ebx, eax       

					mov		eax, edx
					shr		eax, 4
					and		eax, bmask4   
					sub		ebx, eax      

					mov		ax, [edi]			
					mov		edx, eax
					shr		eax, 1
					and		eax, bmask1   
					add		ebx, eax      
					
					mov		eax, edx
					shr		eax, 2
					and		eax, bmask2   
					add		ebx, eax       
					
					mov		eax, edx
					shr		eax, 3
					and		eax, bmask3    
					add		ebx, eax       

					shr   eax, 4
					and		eax, bmask4    // clip bck
					add		ebx, eax          // shift bck pix bits right
					
					mov		[edi], bx       // store new pixel

			Skip30:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop30b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop30a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 31:		//alpha blending with color key using LUT
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			alphashift=2048*srcalpha;
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop31a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop31b:
					xor		eax, eax
					xor		ebx, ebx
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip31
					push  ecx
					mov		bx, [edi]       // get background pixel

					mov   scol, ax
					mov		dcol, bx
					//red
					shr		ax, 11
					shr		bx, 11
					//and   eax, bmaskdw
					//and		ebx, bmaskdw

					mov		edx, alphatable
					add		edx, alphashift
					shl   eax, 6
					add   edx, eax
					add   edx, ebx
					add   edx, ebx
					inc   edx
					inc   edx
					mov		cx, [edx]
					//and		ecx, bmaskdw
					shl   cx, 11	

					//blue
					mov		ax, scol       // get sprite pixel
					mov		bx, dcol       // get background pixel
					and   eax, bmaskdw
					and		ebx, bmaskdw
					mov		edx, alphatable
					add		edx, alphashift
					shl   eax, 6
					add   edx, eax
					add   edx, ebx
					add   edx, ebx
					inc   edx
					inc   edx
					mov   ax, [edx]
					//and   eax, bmaskdw
					add		cx, ax	

					//green 
					mov		ax, scol       // get sprite pixel
					mov		bx, dcol       // get background pixel
					and   eax, gmaskdw
					and		ebx, gmaskdw
					//change to 5 if 555
					shr		eax, 6
					shr		ebx, 6
					mov		edx, alphatable
					add		edx, alphashift
					shl   eax, 6
					add   edx, eax
					add   edx, ebx
					add   edx, ebx
					inc   edx
					inc   edx
					mov   ax, [edx]
					shl		ax, 6
					//and   eax, gmaskdw
					add		cx, ax
					mov		[edi], cx       // store new pixel
					pop		ecx

			Skip31:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop31b
					//loop	Loop31b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop31a
					//loop	Loop31a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 310:		//alpha blending with color key using LUT 555
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			alphashift=2048*srcalpha;
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop310a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop310b:
					xor		eax, eax
					xor		ebx, ebx
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip310
					push  ecx
					mov		bx, [edi]       // get background pixel

					mov   scol, ax
					mov		dcol, bx
					//red
					shr		ax, 10
					shr		bx, 10
					//and   eax, bmaskdw
					//and		ebx, bmaskdw

					mov		edx, alphatable
					add		edx, alphashift
					shl   eax, 6
					add   edx, eax
					add   edx, ebx
					add   edx, ebx
					inc   edx
					inc   edx
					mov		cx, [edx]
					//and		ecx, bmaskdw
					shl   cx, 10	

					//blue
					mov		ax, scol       // get sprite pixel
					mov		bx, dcol       // get background pixel
					and   eax, 0x01f		//bmaskdw
					and		ebx, 0x01f			//bmaskdw

					mov		edx, alphatable
					add		edx, alphashift
					shl   eax, 6
					add   edx, eax
					add   edx, ebx
					add   edx, ebx
					inc   edx
					inc   edx
					mov   ax, [edx]
					//and   eax, bmaskdw
					add		cx, ax	

					//green 
					mov		ax, scol       // get sprite pixel
					mov		bx, dcol       // get background pixel
					and   eax, 0x3e0			//gmaskdw
					and		ebx, 0x3e0		//gmaskdw
					//			7e0  565
					//			3e0  555
					//change to 5 if 555
					shr		eax, 5
					shr		ebx, 5
					mov		edx, alphatable
					add		edx, alphashift
					shl   eax, 6
					add   edx, eax
					add   edx, ebx
					add   edx, ebx
					inc   edx
					inc   edx
					mov   ax, [edx]
					shl		ax, 5
					//and   eax, gmaskdw
					add		cx, ax
					mov		[edi], cx       // store new pixel
					pop		ecx

			Skip310:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop310b
					//loop	Loop31b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop310a
					//loop	Loop31a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;

			
//*********************************************************************
		case 32:		//alpha blending with color key 4 levels
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop32a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop32b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip32

					mov		ebx, eax
					mov   edx, eax
					
					shr		eax, 1
					and		eax, bmask1    
					sub		ebx, eax       
					
					mov		eax, edx
					shr		eax, 2
					and		eax, bmask2    
					sub		ebx, eax       

					mov		ax, [edi]			
					mov		edx, eax
					shr		eax, 1
					and		eax, bmask1   
					add		ebx, eax      
					
					mov		eax, edx
					shr		eax, 2
					and		eax, bmask2   
					add		ebx, eax       
					
					mov		[edi], bx       // store new pixel

			Skip32:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop32b
					//loop	Loop32b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop32a
					//loop	Loop32a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 33:		//alpha blending with color key addition
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop33a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop33b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip33
					mov   bx, [edi]

					add   bx, ax
					mov		[edi], bx       // store new pixel

			Skip33:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop33b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop33a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 34:		//alpha blending with color key ...2 imuls
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop34a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop34b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip34
					
					//spread the sprite pixel
					mov		edx, ecx
					mov		eax, ecx
					shl		eax, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		eax, edx
					or		eax, ecx
					and		eax, 0x3e0fc1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		edx, ecx
					mov		ebx, ecx
					shl		ebx, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background

					

					imul	eax,	srcalpha				//alpha
					shr		eax,5

					mov		ecx, 32
					sub		ecx, srcalpha

					imul	ebx,	ecx				//alpha
					shr		ebx,5
					//and		ebx, 0x3e0fc1f	//imulmask

					add		eax, ebx

					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shl cx, 11
					shr edx, 21
					shr ax, 5
					and eax, 0x7e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel



			Skip34:
					pop		ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop34b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop34a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 340:		//alpha blending with color key ...2 imuls
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop340a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop340b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip340
					
					//spread the sprite pixel
					mov		edx, ecx
					mov		eax, ecx
					shl		eax, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 10
					or		eax, edx
					or		eax, ecx
					and		eax, 0x3e07c1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		edx, ecx
					mov		ebx, ecx
					shl		ebx, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 10
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background

					

					imul	eax,	srcalpha				//alpha
					shr		eax,5

					mov		ecx, 32
					sub		ecx, srcalpha

					imul	ebx,	ecx				//alpha
					shr		ebx,5
					//and		ebx, 0x3e0fc1f	//imulmask

					add		eax, ebx


					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shl cx, 10
					shr edx, 21
					shr ax, 5
					and eax, 0x3e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel



			Skip340:
					pop		ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop340b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop340a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;


//*********************************************************************
		case 35:		//alpha blending with color key addition...
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop35a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop35b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip35
					
					//spread the sprite pixel
					mov		edx, ecx
					mov		eax, ecx
					shl		eax, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		eax, edx
					or		eax, ecx
					and		eax, 0x3e0fc1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		edx, ecx
					mov		ebx, ecx
					shl		ebx, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background

					

					//and		ebx, 0x3e0fc1f	//imulmask

					add		eax, ebx

					test  eax, bover
					jz		NobOver35
					//xor		eax, bover
					or		eax, pureblue
			NobOver35:
					test  eax, gover
					jz		NogOver35
					//xor		eax, gover
					or		eax, puregreen
			NogOver35:
					test  eax, rover
					jz		NorOver35
					//xor		eax, rover
					or		eax, purered
			NorOver35:

					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shl cx, 11
					shr edx, 21
					shr ax, 5
					and eax, 0x7e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel



			Skip35:
					pop		ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop35b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop35a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 350:		//alpha blending with color key addition...
			//needs debugging
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop350a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop350b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip350
					
					//spread the sprite pixel
					mov		edx, ecx
					mov		eax, ecx
					shl		eax, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 10
					or		eax, edx
					or		eax, ecx
					and		eax, 0x3e07c1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		edx, ecx
					mov		ebx, ecx
					shl		ebx, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 10
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background

					

					//and		ebx, 0x3e0fc1f	//imulmask

					add		eax, ebx

					test  eax, bover
					jz		NobOver350
					//xor		eax, bover
					or		eax, pureblue
			NobOver350:
					test  eax, gover
					jz		NogOver350
					//xor		eax, gover
					or		eax, puregreen
			NogOver350:
					test  eax, rover
					jz		NorOver350
					//xor		eax, rover
					or		eax, purered
			NorOver350:

					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shl cx, 10
					shr edx, 21
					shr ax, 5
					and eax, 0x3e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel



			Skip350:
					pop		ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop350b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop350a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 36:		//alpha blending with color key source and dest levels
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop36a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop36b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip36
					
					//spread the sprite pixel
					mov		eax, ecx
					mov		edx, ecx
					shl		eax, 21
					and		edx, 0x7e0					//gmaskdw
					shr		ecx, 11
					shl		edx, 5
					or		eax, ecx
					or		eax, edx
					and		eax, 0x3e0fc1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		ebx, ecx
					mov		edx, ecx
					shl		ebx, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background


					//and		ebx, 0x3e0fc1f	//imulmask
					imul	eax, srcalpha
					imul	ebx, destalpha
					
					shr		eax, 5
					shr		ebx, 5

					and		eax, 0x3e0fc1f	//imulmask
					and		ebx, 0x3e0fc1f	//imulmask

					add		eax, ebx


					test  eax, 0xC030060			//test all at once
					jz		NoOver36
//					mov		eax, 0x3E0FC1F

					test  eax, 0xC000000			//bover
					jz		NobOver36
					//xor		eax, bover
					or		eax, 0x3e00000			//pureblue
			NobOver36:
					test  eax, 0x30000				//gover
					jz		NogOver36
					//xor		eax, gover
					or		eax, 0x0fc00				//puregreen
			NogOver36:
					test  eax, 0x60						//rover
					jz		NorOver36
					//xor		eax, rover
					or		eax, 0x1f						//purered
			NorOver36:

			NoOver36:
					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shr ax, 5
					shl cx, 11
					and eax, 0x7e0					//gmaskdw
					shr edx, 21
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel



			Skip36:
					pop		ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop36b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop36a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 360:		//alpha blending with color key source and dest levels
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop360a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop360b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip360
					
					//spread the sprite pixel
					mov		eax, ecx
					mov		edx, ecx
					shl		eax, 21
					and		edx, 0x3e0					//gmaskdw
					shr		ecx, 10
					shl		edx, 5
					or		eax, ecx
					or		eax, edx
					and		eax, 0x3e07c1f	//imulmask
					
					//spread the destination pixel
					mov		cx,  [edi]
					mov		ebx, ecx
					mov		edx, ecx
					shl		ebx, 21
					and		edx, 0x3e0					//gmaskdw
					shr		ecx, 10
					shl		edx, 5
					or		ebx, ecx
					or		ebx, edx
					and		ebx, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//eax contains sprite, ebx contains background


					//and		ebx, 0x3e0fc1f	//imulmask
					imul	eax, srcalpha
					imul	ebx, destalpha
					shr		eax, 5
					shr		ebx, 5

					and		eax, 0x3e07c1f	//imulmask
					and		ebx, 0x3e07c1f	//imulmask

					add		eax, ebx

					test  eax, bover
					jz		NobOver360
					//xor		eax, bover
					or		eax, pureblue
			NobOver360:
					test  eax, gover
					jz		NogOver360
					//xor		eax, gover
					or		eax, puregreen
			NogOver360:
					test  eax, rover
					jz		NorOver360
					//xor		eax, rover
					or		eax, purered
			NorOver360:

					//pack from eax
					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shr ax, 5
					shl cx, 10
					and eax, 0x3e0					//gmaskdw
					shr edx, 21
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel



			Skip360:
					pop		ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop360b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop360a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;


//*********************************************************************
		case 37:		//alpha blending with shift 50%
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			setbmask(srcalpha);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul  esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop37a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop37b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip37
					mov   bx, [edi]
					shr		ax, 1
					shr		bx, 1
					and		eax, bitmask1
					and		ebx, bitmask1
					
					add   bx, ax
					mov		[edi], bx       // store new pixel

			Skip37:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz		Loop37b
					//loop	Loop30b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop37a
					//loop	Loop30a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
			

//*********************************************************************
		case 40:			//darkened 50%
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop40a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
					//my part
					test	ecx, 1
					jz		NotOdd40
					mov		ax, [esi]				// get sprite pixel
					shr		eax, 1          // shift spr pix bits right
					and		eax, bitmask    // clip spr
					mov		[edi], ax       // store new pixel
					add		esi, 2
					add		edi, 2
					
			NotOdd40:
					mov bx, 0
					shr		ecx, 1
					test	edi, 3
					jz		Loop40b // target aligned

					// target unaligned, do align
					mov		ax, [esi]				// get sprite pixel
					shr		eax, 1          // shift spr pix bits right
					and		eax, bitmask    // clip spr
					mov		[edi], ax       // store new pixel
					add		esi, 2
					add		edi, 2
					dec		ecx
					mov		bx, 1
			Loop40b:
					mov		eax, [esi]       // get 2 sprite pixels
					shr		eax, 1           // shift spr pix bits right
					and		eax, bitmask     // clip spr
					mov		[edi], eax       // store new pixels
					add		esi, 4           // move to next 2 pixels
					add		edi, 4
					loop	Loop40b

					//test	edi, 3
					test	bx, 1
					jz		NxtLne40 // target aligned
					mov		ax, [esi]				// get sprite pixel
					shr		eax, 1          // shift spr pix bits right
					and		eax, bitmask    // clip spr
					mov		[edi], ax       // store new pixel

			NxtLne40:
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop40a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 41:			//darkened 75%
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop41a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
					//my part
					test	ecx, 1
					jz		NotOdd41
					mov		ax, [esi]				// get sprite pixel
					shr		eax, 2          // shift spr pix bits right
					and		eax, bitmask2    // clip spr
					mov		[edi], ax       // store new pixel
					add		esi, 2
					add		edi, 2
					
			NotOdd41:
					mov bx, 0
					shr		ecx, 1
					test	edi, 3
					jz		Loop41b // target aligned

					// target unaligned, do align
					mov		ax, [esi]				// get sprite pixel
					shr		eax, 2          // shift spr pix bits right
					and		eax, bitmask2    // clip spr
					mov		[edi], ax       // store new pixel
					add		esi, 2
					add		edi, 2
					dec		ecx
					mov		bx, 1
			Loop41b:
					mov		eax, [esi]       // get 2 sprite pixels
					shr		eax, 2           // shift spr pix bits right
					and		eax, bitmask2     // clip spr
					mov		[edi], eax       // store new pixels
					add		esi, 4           // move to next 2 pixels
					add		edi, 4
					loop	Loop41b

					//test	edi, 3
					test	bx, 1
					jz		NxtLne41 // target aligned
					mov		ax, [esi]				// get sprite pixel
					shr		eax, 2          // shift spr pix bits right
					and		eax, bitmask2    // clip spr
					mov		[edi], ax       // store new pixel

			NxtLne41:
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz		Loop41a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 50:		//darken color keyed, 50%
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;
			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop50a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop50b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip50
					mov		edx, eax
					shr		eax, 2         // shift spr pix bits right
					and		eax, bitmask2    // clip spr
					sub		edx, eax
					mov		[edi], ax       // store new pixel

			Skip50:
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop50b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop50a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 51:		//darken color keyed using imul
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;
			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		ebx, srcalpha
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop51a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop51b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip51
					mov		edx, ecx
					mov		eax, ecx
					shl		eax, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		eax, edx
					or		eax, ecx
					and		eax, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565
					imul eax,	ebx				//alpha
					shr eax,5

					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shl cx, 11
					shr edx, 21
					shr ax, 5
					and eax, 0x7e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel

			Skip51:
					pop   ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop51b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop51a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 510:		//darken color keyed using imul
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;
			
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		ebx, srcalpha
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop510a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop510b:
					push  ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip510
					mov		edx, ecx
					mov		eax, ecx
					shl		eax, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 10
					or		eax, edx
					or		eax, ecx
					and		eax, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565
					imul eax,	ebx				//alpha
					shr eax,5

					//and eax,imulmask					
					mov ecx, eax
					mov edx, eax
					shl cx, 10
					shr edx, 21
					shr ax, 5
					and eax, 0x3e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		ax, cx
					or		ax, dx
					mov		[edi], ax       // store new pixel

			Skip510:
					pop   ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop510b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop510a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;


//*********************************************************************
		case 52:		//darken with shifts
			setbmask(srcalpha);
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop52a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop52b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip52
					mov		bx, [edi]       // get background pixel
					mov		ebx, eax
					mov		edx, eax
					
					shr		eax, 1
					and		eax, bmask1    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		eax, edx
					shr		eax, 2
					and		eax, bmask2    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		eax, edx
					shr		eax, 3
					and		eax, bmask3    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		eax, edx
					shr		eax, 4
					and		eax, bmask4    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		[edi], bx       // store new pixel
			Skip52:
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop52b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop52a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
			
//*********************************************************************
		case 60:		//shadow
			setbmask(srcalpha);
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop60a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop60b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip60
					mov		bx, [edi]       // get background pixel
					mov		eax, ebx
					mov		edx, eax
					
					shr		eax, 1
					and		eax, bmask1    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		eax, edx
					shr		eax, 2
					and		eax, bmask2    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		eax, edx
					shr		eax, 3
					and		eax, bmask3    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		eax, edx
					shr		eax, 4
					and		eax, bmask4    // clip bck
					sub		ebx, eax          // shift bck pix bits right
					mov		[edi], bx       // store new pixel
			Skip60:
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop60b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop60a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 61:				//lighten
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop61a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop61b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip61
					mov		bx, [edi]       // get background pixel
					mov		eax, ebx
					shr		eax, 1
					and		eax, bitmask    // clip bck
					add		ebx, eax        
					mov		[edi], bx       // store new pixel
			Skip61:
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop61b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop61a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 62:		//shadow 50%
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop62a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop62b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip62
					mov		bx, [edi]       // get background pixel
					
					shr		bx, 1
					and		ebx, bitmask1
					
					mov		[edi], bx       // store new pixel
			Skip62:
					add		esi, 2          // move to next pixel
					add		edi, 2
					loop	Loop62b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					loop	Loop62a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 63:				//lighten  check
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop63a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop63b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip63

					push	ecx
	
					mov		cx, [edi]       // get background pixel
					//spread the destination pixel
					mov		edx, ecx
					mov		ebx, ecx
					shl		ebx, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					shl		ebx, 1
					//and		ebx, 0x3e0fc1f	//imulmask

					
/*					//add the light
					shr		ax,  12			//red /2
					//add		ax,  16
					imul	ebx, ax
					shr		ebx, 4
*/

					//and		ebx, 0x3e0fc1f	//imulmask
					test  ebx, bover
					jz		NobOver63
					//xor		ebx, bover
					or		ebx, pureblue
			NobOver63:
					test  ebx, gover
					jz		NogOver63
					//xor		ebx, gover
					or		ebx, puregreen
			NogOver63:
					test  ebx, rover
					jz		NorOver63
					//xor		ebx, rover
					or		ebx, purered
			NorOver63:

					//pack from eax
					//and eax,imulmask					
					mov ecx, ebx
					mov edx, ebx
					shl cx, 11
					shr edx, 21
					shr bx, 5
					and ebx, 0x7e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		bx, cx
					or		bx, dx
				

//					mov		eax, ebx
//					shr		eax, 1
//					and		eax, bitmask    // clip bck
//					add		ebx, eax        

					
					mov		[edi], bx       // store new pixel

					pop ecx
			Skip63:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz	Loop63b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz	Loop63a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

//*********************************************************************
		case 630:				//lighten  check		555
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop630a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop630b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip630

					push	ecx
	
					mov		cx, [edi]       // get background pixel
					//spread the destination pixel
					mov		edx, ecx
					mov		ebx, ecx
					shl		ebx, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		ecx, 11
					or		ebx, edx
					or		ebx, ecx
					and		ebx, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					shl		ebx, 1
					//and		ebx, 0x3e0fc1f	//imulmask

					
/*					//add the light
					shr		ax,  12			//red /2
					//add		ax,  16
					imul	ebx, ax
					shr		ebx, 4
*/

					//and		ebx, 0x3e0fc1f	//imulmask
					test  ebx, bover
					jz		NobOver630
					//xor		ebx, bover
					or		ebx, pureblue
			NobOver630:
					test  ebx, gover
					jz		NogOver630
					//xor		ebx, gover
					or		ebx, puregreen
			NogOver630:
					test  ebx, rover
					jz		NorOver630
					//xor		ebx, rover
					or		ebx, purered
			NorOver630:

					//pack from eax
					//and eax,imulmask					
					mov ecx, ebx
					mov edx, ebx
					shl cx, 10
					shr edx, 21
					shr bx, 5
					and ebx, 0x3e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		bx, cx
					or		bx, dx

					mov		[edi], bx       // store new pixel

					pop ecx
			Skip630:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz	Loop630b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz	Loop630a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
			
//*********************************************************************
		case 64:				//variable lighten  check
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop64a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop64b:
					push	ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip64

	
					mov		ax, [edi]       // get background pixel
					//spread the destination pixel
					mov		edx, eax
					mov		ebx, eax
					shl		ebx, 21
					and		edx, 0x7e0					//gmaskdw
					shl		edx, 5
					shr		eax, 11
					or		ebx, edx
					or		ebx, eax
					and		ebx, 0x3e0fc1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//shl		ebx, 1
					//and		ebx, 0x3e0fc1f	//imulmask

					
					//add the light			//1-2 times
//					shr		cx,  12			//red /4
//					add		cx,  16
//					imul	ebx, cx
//					shr		ebx, 4

					mov		ax,  cx				//1-5 times
					shr		ax,  13
					shr		cx,  11			//red /4
					sub		cx,  ax
					add		cx,  8
					imul	ebx, cx
					shr		ebx, 3


//					shr		cx,  11			
//					imul	ebx, cx			//0-4 times
//					shr		ebx, 3

//					shr		cx,  11			//
//					imul	ebx, cx			//0-2 times
//					shr		ebx, 4

					//and		ebx, 0x3e0fc1f	//imulmask
					test  ebx, bover
					jz		NobOver64
					//xor		ebx, bover
					or		ebx, pureblue
			NobOver64:
					test  ebx, gover
					jz		NogOver64
					//xor		ebx, gover
					or		ebx, puregreen
			NogOver64:
					test  ebx, rover
					jz		NorOver64
					//xor		ebx, rover
					or		ebx, purered
			NorOver64:

					//pack from eax
					//and eax,imulmask					
					mov ecx, ebx
					mov edx, ebx
					shl cx, 11
					shr edx, 21
					shr bx, 5
					and ebx, 0x7e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		bx, cx
					or		bx, dx
				

//					mov		eax, ebx
//					shr		eax, 1
//					and		eax, bitmask    // clip bck
//					add		ebx, eax        

					
					mov		[edi], bx       // store new pixel

			Skip64:
					pop ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz	Loop64b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz	Loop64a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;
//*********************************************************************
		case 640:				//variable lighten  check
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop640a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop640b:
					push	ecx
					mov		cx, [esi]       // get sprite pixel
					cmp		cx, TRANSCOLOR  // check if it's transparent
					je		Skip640

	
					mov		ax, [edi]       // get background pixel
					//spread the destination pixel
					mov		edx, eax
					mov		ebx, eax
					shl		ebx, 21
					and		edx, 0x3e0					//gmaskdw
					shl		edx, 5
					shr		eax, 10
					or		ebx, edx
					or		ebx, eax
					and		ebx, 0x3e07c1f	//imulmask
					//				3e07c1f 555
					//				3e0fc1f	565

					//shl		ebx, 1
					//and		ebx, 0x3e0fc1f	//imulmask

					
					//add the light			//1-2 times
//					shr		cx,  11			//red /4
//					add		cx,  16
//					imul	ebx, cx
//					shr		ebx, 4

					mov		ax,  cx				//1-5 times
					shr		ax,  12
					shr		cx,  10			//red /4
					sub		cx,  ax
					add		cx,  8
					imul	ebx, cx
					shr		ebx, 3


//					shr		cx,  10			
//					imul	ebx, cx			//0-4 times
//					shr		ebx, 3

//					shr		cx,  10			//
//					imul	ebx, cx			//0-2 times
//					shr		ebx, 4

					//and		ebx, 0x3e0fc1f	//imulmask
					test  ebx, bover
					jz		NobOver640
					//xor		ebx, bover
					or		ebx, pureblue
			NobOver640:
					test  ebx, gover
					jz		NogOver640
					//xor		ebx, gover
					or		ebx, puregreen
			NogOver640:
					test  ebx, rover
					jz		NorOver640
					//xor		ebx, rover
					or		ebx, purered
			NorOver640:

					//pack from eax
					//and eax,imulmask					
					mov ecx, ebx
					mov edx, ebx
					shl cx, 10
					shr edx, 21
					shr bx, 5
					and ebx, 0x3e0					//gmaskdw
					//			7e0  565
					//			3e0  555
					or		bx, cx
					or		bx, dx
				

//					mov		eax, ebx
//					shr		eax, 1
//					and		eax, bitmask    // clip bck
//					add		ebx, eax        

					
					mov		[edi], bx       // store new pixel

			Skip640:
					pop ecx
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz	Loop640b
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					add		esi, ddsdSpr.lPitch
					dec		ecx
					jnz	Loop640a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);
			break;

			
//*********************************************************************
		case 70:		//replace with color key red->blue
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			//dcol=0;
			//if (srcalpha>=8) dcol=0x7800;
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					//mov		cl,  darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop70a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop70b:
//					xor		eax, eax
//					xor		ebx, ebx
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip70
					
					shr		ax, 11
					//shr		ax, 1
					//and		eax, bitmask1
					mov		[edi], ax       // store new pixel

			Skip70:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop70b
					//loop	Loop70b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop70a
					//loop	Loop70a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 71:		//replace with color key red->green
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop71a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop71b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip71
					//red
					shr		ax, 11
					//6 for 565
					shl   ax, 6
					mov		[edi], ax       // store new pixel

			Skip71:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop71b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop71a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 72:		//replace with color key red
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					//fix this sometime
					//mov		ebx, purered
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop72a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop72b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip72
					//red
					shr		ax, 11
					shl		ax, 11
					//6 for 565
					mov		[edi], ax       // store new pixel

			Skip72:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop72b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop72a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 73:		//replace with color key red->blue+green
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop73a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop73b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip73
					//red
					shr		ax, 11
					//6 for 565
					mov   dx, ax
//					shr		ax, 1
//					shr		dx, 1
					shl   dx, 6
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip73:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop73b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop73a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 74:		//replace with color key red->blue red
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop74a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop74b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip74
					//red
					shr		ax, 11
					//6 for 565
					mov   dx, ax
//					shr		ax, 1
//?					shr		dx, 1
					shl   dx, 11
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip74:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop74b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop74a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 75:		//replace with color key red->red green
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop75a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop75b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip75
					//red
					shr		ax, 11
					//6 for 565
					mov   dx, ax
					shl		ax, 11
//					shr		dx, 1
					shl   dx, 6
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip75:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop75b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop75a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 76:		//replace with color key red->grey scale
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop76a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop76b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip76
					//red
					shr		ax, 11
					//6 for 565
					mov   dx, ax
//					shr		dx, 1
					shl   dx, 6
					add		ax, dx
					shl   dx, 5
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip76:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop76b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop76a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 77:		//replace with color key red->half blue red
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
					
			Loop77a:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loop77b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip77
					shr		ax, 11

					mov   dx, ax
					shl		ax, 11
					shr		dx, 1
					shl   dx, 6
					add		ax, dx

					//shr		ax, 11
					//mov   dx, ax
					//shr		ax, 1
					//shl   dx, 11
					//add		ax, dx

					mov		[edi], ax       // store new pixel

			Skip77:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ecx
					jnz   Loop77b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ecx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ecx
					jnz		Loop77a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
//700 series is replace color for 555
//*********************************************************************
		case 700:		//replace with color key red->blue
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			//dcol=0;
			//if (srcalpha>=8) dcol=0x7800;
			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop700a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop700b:
//					xor		eax, eax
//					xor		ebx, ebx
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip700
					
					shr		ax, 10
					shr		ax, cl
					//shr		ax, 1
					//and		eax, bitmask1
					mov		[edi], ax       // store new pixel

			Skip700:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop700b
					//loop	Loop70b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop700a
					//loop	Loop70a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 710:		//replace with color key red->green
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop710a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop710b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip710
					//red
					shr		ax, 10
					shr		ax, cl
					//6 for 565
					shl   ax, 5
					mov		[edi], ax       // store new pixel

			Skip710:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop710b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop710a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 720:		//replace with color key red
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop720a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop720b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip720
					shr		ax, 10
					shr		ax, cl
					shl		ax, 10
					//red
					//and		eax, ebx
					//6 for 565
					mov		[edi], ax       // store new pixel

			Skip720:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop720b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop720a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 730:		//replace with color key red->blue+green
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop730a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop730b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip730
					//red
					shr		ax, 10
					shr		ax, cl
					//6 for 565
					mov   dx, ax
//					shr		ax, 1
//					shr		dx, 1
					shl   dx, 5
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip730:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop730b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop730a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 740:		//replace with color key red->blue red
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop740a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop740b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip740
					//red
					shr		ax, 10
					shr		ax, cl
					//6 for 565
					mov   dx, ax
//					shr		ax, 1
//?					shr		dx, 1
					shl   dx, 10
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip740:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop740b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop740a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 750:		//replace with color key red->red green
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop750a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop750b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip750
					//red
					shr		ax, 10
					shr		ax, cl
					//6 for 565
					mov   dx, ax
					shl		ax, 10
//					shr		dx, 1
					shl   dx, 5
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip750:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop750b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop750a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 760:		//replace with color key red->grey scale
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop760a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop760b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip760
					//red
					shr		ax, 10
					shr		ax, cl
					//6 for 565
					mov   dx, ax
//					shr		dx, 1
					shl   dx, 5
					add		ax, dx
					shl   dx, 5
					add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip760:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop760b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop760a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;
//*********************************************************************
		case 770:		//replace with color key red->orange
			//ZeroMemory(&ddsdSpr, sizeof(ddsdSpr));
			//ddsdSpr.dwSize = sizeof(ddsdSpr);
			deltax=srcrect.right-srcrect.left;
			deltay=srcrect.bottom-srcrect.top;
			
			x=srcrect.left;
			y=srcrect.top;

			dderror = pSrc->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;

			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		cl, darkshift
					mov		esi, y
					imul	esi, ddsdSpr.lPitch
					add		esi, x
					add		esi, x
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY
					imul	edi, ddsdBack.lPitch
					add		edi, sprX
					add		edi, sprX
					add		edi, ddsdBack.lpSurface
					mov		ebx, deltay
					
			Loop770a:
					push	ebx
					push	esi
					push	edi
					mov		ebx, deltax
			Loop770b:
					mov		ax, [esi]       // get sprite pixel
					cmp		ax, TRANSCOLOR  // check if it's transparent
					je		Skip770

					shr		ax, 10
					shr		ax, cl

					mov   dx, ax
					shl		ax, 10
					shr		dx, 1
					shl   dx, 5
					add		ax, dx

					//shr		ax, 10
					//mov   dx, ax
					//shr		ax, 1
					//shl   dx, 10
					//add		ax, dx
					mov		[edi], ax       // store new pixel

			Skip770:
					add		esi, 2          // move to next pixel
					add		edi, 2
					dec		ebx
					jnz   Loop770b
					//loop	Loop71b
					pop		edi
					pop		esi
					pop		ebx
					add		edi, ddsdBack.lPitch
					add		esi, ddsdSpr.lPitch
					dec   ebx
					jnz		Loop770a
					//loop	Loop71a
				}
			}

			pDst->Unlock(ddsdBack.lpSurface);
			pSrc->Unlock(ddsdSpr.lpSurface);

			break;

			
		}//end case
}//end myblit


void SBlit(LPDIRECTDRAWSURFACE pSrc1, LPDIRECTDRAWSURFACE pDst1, int sprX1, int sprY1, int blitmode1, int srcalpha1, RECT srcrect1, int resv1)
{
	//RECT				rect;
			static int size, angle, sizedir;
			int	xa1, ya1, dxa1, dya1, intxa1, intya1;
			int i;
			//static int count, sizedir;

			memset( &ddsdSpr, 0, sizeof( ddsdSpr ) );
				ddsdSpr.dwSize = sizeof( ddsdSpr );
			if (!SUCCEEDED(pSrc1->GetSurfaceDesc( &ddsdSpr ))) return;

			deltax=srcrect1.right-srcrect1.left;
			deltay=srcrect1.bottom-srcrect1.top;

			x=srcrect1.left;
			y=srcrect1.top;
			DWORD	xstart,ystart;
			if (sizedir==0) sizedir=2;
//			count+=1;
			//if (count>3) {count-=3;alpha+=1;}
			size+=sizedir;
			if (size>256) {size=256;sizedir*=-1;}
			if (size<4) {size=4;sizedir*=-1;}
//		
			//size=200;
			angle+=2;
			if (angle>360) angle-=360;
			if (angle<0) angle+=360;
			xa1=0;
			ya1=0;
			dxa1=mycos[angle]*128/size;
			dya1=mysin[angle]*128/size;

			deltax=deltax*size/128;
			deltay=deltay*size/128;

			for (i=1;i<deltax+1;i++) {
			  xa1+=dxa1;
				ya1+=dya1;
				
				xchp[i]=0;
				ychp[i]=0;
				intxa1=abs(xa1/128);
				intya1=abs(ya1/128);
				if (xa1>128) {
					xchp[i]+=2*intxa1;
					ychp[i]+=ddsdSpr.lPitch*intxa1;
					xa1-=128*intxa1;
				} else if (xa1<-128) {
					xchp[i]-=2*intxa1;
					ychp[i]-=ddsdSpr.lPitch*intxa1;
					xa1+=128*intxa1;
				}
				if (ya1>128) {
					xchp[i]+=ddsdSpr.lPitch*intya1;
					ychp[i]-=2*intya1;
					ya1-=128*intya1;
				} else if (ya1<-128) {
					xchp[i]-=ddsdSpr.lPitch*intya1;
					ychp[i]+=2*intya1;
					ya1+=128*intya1;
				}
			}
			xstart=DWORD(200-141.4*sin((45-angle)*3.1415/180));
			ystart=DWORD(200-141.4*cos((45-angle)*3.1415/180));

			if ((sprX1+deltax)>=640) deltax=640-sprX1;	
			if ((sprY1+deltay)>=480) deltay=480-sprY1;	


			dderror = pSrc1->Lock(NULL, &ddsdSpr, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
			ZeroMemory(&ddsdBack, sizeof(ddsdBack));
			ddsdBack.dwSize = sizeof(ddsdBack);
			dderror = pDst1->Lock(NULL, &ddsdBack, DDLOCK_SURFACEMEMORYPTR|DDLOCK_WAIT, NULL);
			if(dderror != DD_OK) return;
//			pDst->Unlock(ddsdBack.lpSurface);
//			pSrc->Unlock(ddsdSpr.lpSurface);
	switch(blitmode1)
	{
	default:
			if(ddsdSpr.lpSurface && ddsdBack.lpSurface)
			{
				__asm{
					mov		esi, ystart
					imul	esi, ddsdSpr.lPitch
					add		esi, xstart
					add		esi, xstart
					add		esi, ddsdSpr.lpSurface

					mov		edi, sprY1
					imul	edi, ddsdBack.lPitch
					add		edi, sprX1
					add		edi, sprX1
					add		edi, ddsdBack.lpSurface
					mov		ecx, deltay
			Loopsa:
					push	ecx
					push	esi
					push	edi
					mov		ecx, deltax
			Loopsb:
					mov		ax, [esi]
					cmp		ax, TRANSCOLOR
					je		Skips
					mov		[edi], ax
			Skips:
					//mov		edx, ecx
					//shl		edx, 2
					//add		edx, xchp
					//mov		eax, [edx]
					//add		esi, eax		
					add		esi, [ecx*4]+xchp		//
					//add		esi, ddsdSpr.lPitch
					add		edi, 2
					dec		ecx
					jnz		Loopsb
					pop		edi
					pop		esi
					add		edi, ddsdBack.lPitch
					pop		ecx
					mov		edx, ecx
					shl		edx, 2
					add		edx, ychp
					mov		eax, [edx]
					add		esi, eax
					dec		ecx
					jnz	Loopsa
				}
			}

			pDst1->Unlock(ddsdBack.lpSurface);
			pSrc1->Unlock(ddsdSpr.lpSurface);
	}
	return;
}
